

int num_x = 7;
int num_y = 6;
int box_size = 50;
int circle_size = 40;
int[][] entered = new int [num_x][num_y];

int px = 0;
int py = 0;

void setup() {
  size( num_x * box_size, num_y * box_size );
  strokeWeight(2);
}

void draw() {
  entered[px][py] = 1;

  // 碁盤を描く  
  for (int j=0; j<num_y; j++) {
    for (int i=0; i<num_x; i++) {
      if (entered[i][j]==1) {
        fill(0,255,0);
      } else {
        fill(255);
      }
      rect( i*box_size, j*box_size, box_size, box_size );
    }
  }

  fill(255);
  ellipse( box_size * (px+0.5), box_size * (py+0.5), circle_size, circle_size );
}


void keyPressed() {
  int tx = px;
  int ty = py;
  
  if (keyCode==UP) {
    ty--;
  }
  if (keyCode==DOWN) {
    ty++;
  }
  if (keyCode==LEFT) {
    tx--;
  }
  if (keyCode==RIGHT) {
    tx++;
  }
  
  if (tx>=0 && tx<num_x && ty>=0 && ty<num_y) {
    px = tx;
    py = ty;
  }  
}

