
int d = 20;
int num_x = 30;
int num_y = 10;
int[][] light = new int [num_x][num_y];

void setup() {
  size( num_x * d, num_y * d );
}

void draw() {
  background(200);

  for (int j=0; j<num_y; j++) {
    for (int i=0; i<num_x; i++) {
      switch ( light[i][j] ) {
      case 0:
        fill(255);
        break;
      case 1:
        fill(0, 200, 0);
        break;
      case 2:
        fill(200, 200, 0);
        break;
      case 3:
        fill(200, 0, 0);
        break;
      }
      ellipse( d*(i+0.5), d*(j+0.5), d, d );
    }
  }
}

void mousePressed() {
  for (int j=0; j<num_y; j++) {
    for (int i=0; i<num_x; i++) {
      if ( dist(mouseX, mouseY, d*(i+0.5), d*(j+0.5)) < d/2 ) {
        light[i][j]++;
        if ( light[i][j]>3 ) light[i][j] = 0;
      }
    }
  }
}

void keyPressed() {
  if (keyCode==LEFT) {
    for (int j=0; j<num_y; j++) {
      for (int i=0; i<num_x-1; i++) {
        light[i][j] = light[i+1][j];
      }
      light[num_x-1][j] = 0;
    }
  }
}
